// Win32 Tutorial (Edit Boxes)

// Alan Baylis 2004


#include <windows.h>
#include "resource.h"

const char ClassName[] = "MainWindowClass";
HWND hWndEditBox;

LRESULT CALLBACK WndProc( HWND    hWnd,
                          UINT    Msg,
                          WPARAM  wParam,          
                          LPARAM  lParam )
{
    switch (Msg)
    {
        case WM_CREATE:
        {
            hWndEditBox = CreateWindow(
            "EDIT", 
            "Edit Boxes", 
            WS_VISIBLE | WS_CHILD, 
            10, 
            10, 
            100, 
            50, 
            hWnd, 
            (HMENU)IDC_EDITBOX_TEXT, 
            (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE), 
            NULL);

            if (!hWnd)
                MessageBox(NULL, "Edit Box Failed.", "Error", MB_OK | MB_ICONERROR);
        }
        break; 

        case WM_COMMAND: 
        {
            switch(LOWORD(wParam))
            {
                case IDC_EDITBOX_TEXT:
                {
                    switch(HIWORD(wParam))
                    {
                        case EN_CHANGE:
                        {
                            char Buffer[256];
                            GetWindowText((HWND)lParam, Buffer, 256);
                            SetWindowText(hWnd, Buffer);
                        }
                    }
                }
                break;
            }
            return 0;
        } 
        break; 

        case WM_CLOSE:
            DestroyWindow(hWnd);
        break;

        case WM_DESTROY:
            PostQuitMessage(0);
        break;

        default:
            return (DefWindowProc(hWnd, Msg, wParam, lParam));
    }

    return 0;
}

INT WINAPI WinMain( HINSTANCE  hInstance,
                    HINSTANCE  hPrevInstance,
                    LPSTR      lpCmdLine,
                    INT        nCmdShow )
{
    WNDCLASSEX    wc;

    wc.cbSize           = sizeof(WNDCLASSEX);
    wc.style            = 0;
    wc.lpfnWndProc      = (WNDPROC)WndProc;
    wc.cbClsExtra       = 0;
    wc.cbWndExtra       = 0;
    wc.hInstance        = hInstance;
    wc.hIcon            = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
    wc.hIconSm          = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
    wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground    = (HBRUSH)(COLOR_WINDOW + 1);
    wc.lpszMenuName     = NULL;
    wc.lpszClassName    = ClassName;

    if (!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Failed To Register The Window Class.", "Error", MB_OK | MB_ICONERROR);
        return 0;
    }

    HWND    hWnd;

    hWnd = CreateWindowEx(
    WS_EX_CLIENTEDGE,
    ClassName,
    "Edit Boxes",
    WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    240,
    120,
    NULL,
    NULL,
    hInstance,
    NULL);

    if (!hWnd)
    {
        MessageBox(NULL, "Window Creation Failed.", "Error", MB_OK | MB_ICONERROR);
        return 0;
    }

    ShowWindow(hWnd, SW_SHOW);
    UpdateWindow(hWnd);

    MSG    Msg;

    while (GetMessage(&Msg, NULL, 0, 0))
    {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
    }

    return Msg.wParam;
}
